package org.scalaxb.maven;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on scalaxb-maven-plugin.<br/> Call <pre>  mvn scalaxb:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Fri May 18 10:25:04 BST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.scalaxb:scalaxb-maven-plugin:0.7.1", 0 );
        append( sb, "", 0 );

        append( sb, "scalaxb Maven Plugin", 0 );
        append( sb, "Maven plugin for scalaxb, an XML data-binding tool for Scala.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 2 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "generate".equals( goal ) )
        {
            append( sb, "scalaxb:generate", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "attributePrefix", 2 );
                append( sb, "Prefix to prepend to the names of generated parameters for XML attributes.\nThis option sets a prefix to be used in the names of parameters for XML attributes. It is useful when a schema defines both an element and an attribute of the same name within a complex type.", 3 );
                append( sb, "Expression: ${scalaxb.attributePrefix}", 3 );
                append( sb, "", 0 );

                append( sb, "chunkSize", 2 );
                append( sb, "Maximum number of parameters to use in generated case class constructors. This allows parameters sequences to be separated into chunks of the given size.", 3 );
                append( sb, "", 0 );

                append( sb, "classPrefix", 2 );
                append( sb, "The prefix to use on generated classes.", 3 );
                append( sb, "Expression: ${scalaxb.classPrefix}", 3 );
                append( sb, "", 0 );

                append( sb, "generateRuntime (Default: true)", 2 );
                append( sb, "Generate the scalaxb classes required to use the generated bindings. This option is useful for preventing duplicate copies of the scalaxb runtime being present on the classpath when more than one jar contains scalaxb bindings. To prevent the scalaxb runtime sources being generated, this option should be set to false.", 3 );
                append( sb, "", 0 );

                append( sb, "laxAny (Default: false)", 2 );
                append( sb, "Relaxes namespace constraints of xs:any.\nThis option allows xs:any elements declared with a namespace attribute of ##local to contain qualified XML elements. According to the W3C XML Schema recommendation, an XML element that is declared to be in a namespace is not permitted content for an xs:any element with a namespace of ##local. By default, this option is false, thus enforcing this requirement. Setting this option to true allows namespaced content to be used.", 3 );
                append( sb, "Expression: ${scalaxb.lax-any}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory}/generated-sources/scalaxb)", 2 );
                append( sb, "The output directory.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${scalaxb.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "packageDir (Default: true)", 2 );
                append( sb, "Determines whether generated Scala files will be written into a directory corresponding to their package name. By default, the generated files are written in the output directory under a sub-directory that corresponds to the package name. For example, if the generated classes are in package \'foo\', they will be generated in ${scalaxb.outputDirectory}/foo. Setting this value to false will cause the generated sources to be written directly into the output directory, without creating a directory for the package.", 3 );
                append( sb, "Expression: ${scalaxb.package-dir}", 3 );
                append( sb, "", 0 );

                append( sb, "packageName (Default: generated)", 2 );
                append( sb, "The package in which to generate classes. Classes are generated in the package specified, unless the packageNames parameter is used to override this value.", 3 );
                append( sb, "Expression: ${scalaxb.packageName}", 3 );
                append( sb, "", 0 );

                append( sb, "packageNames", 2 );
                append( sb, "Map of namespace URIs to package names for generated classes.\nThis option can be used to override the packageName parameter (see above) for elements in specific namespaces. The mapping between namespace URIs and package names can be specifying any number of packageName elements within the packageNames element. For example:\n<packageNames>\n\u00a0\u00a0<packageName>\n\u00a0\u00a0\u00a0\u00a0<uri>http://example.com/service1</uri>\n\u00a0\u00a0\u00a0\u00a0<package>com.example.service1<package>\n\u00a0\u00a0</packageName>\n\u00a0\u00a0<packageName>\n\u00a0\u00a0\u00a0\u00a0<uri>http://example.com/service2</uri>\n\u00a0\u00a0\u00a0\u00a0<package>com.example.service2<package>\n\u00a0\u00a0</packageName>\n</packageNames>\n", 3 );
                append( sb, "", 0 );

                append( sb, "parameterPrefix", 2 );
                append( sb, "The prefix to use on generated parameter names.", 3 );
                append( sb, "Expression: ${scalaxb.parameterPrefix}", 3 );
                append( sb, "", 0 );

                append( sb, "protocolFile", 2 );
                append( sb, "The name of the file to generate that includes the protocol implementation; that is, the code that marshals values to and from XML.", 3 );
                append( sb, "", 0 );

                append( sb, "protocolPackage", 2 );
                append( sb, "The package in which to generate the \'protocol\' code; that is, the code that marshals values to and from XML. The generated code defines a package object for the named package. The package object defines implicit values required for using the scalaxb.toXML and scalaxb.fromXML functions. If unspecified, the protocol code is generated in the same package as the generated classes that define the values marshalled to and from XML.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${scalaxb.verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "wrapContents", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "wsdlDirectory (Default: ${project.basedir}/src/main/wsdl)", 2 );
                append( sb, "The directory containing the WSDL files. If the specified directory does not exist or is empty, then it is ignored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${scalaxb.wsdlDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "xsdDirectory (Default: ${project.basedir}/src/main/xsd)", 2 );
                append( sb, "The directory containing the XSD files. If the specified directory does not exist or is empty, then it is ignored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${scalaxb.xsdDirectory}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "scalaxb:help", 0 );
            append( sb, "Display help information on scalaxb-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0scalaxb:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
